%bcond_with bootstrap

Summary:       Library to render fonts
Name:          freetype
Version:       2.13.1
Release:       17%{?dist}
License:       FTL or GPLv2+
URL:           https://freetype.org/
Source0:       https://sourceforge.net/projects/freetype/files/freetype2/%{version}/%{name}-%{version}.tar.xz
Source1:       https://sourceforge.net/projects/freetype/files/freetype-docs/%{version}/freetype-doc-%{version}.tar.xz
Source2:       https://sourceforge.net/projects/freetype/files/freetype-demos/%{version}/ft2demos-%{version}.tar.xz
Patch0001: https://gitlab.freedesktop.org/freetype/freetype/-/commit/f42ce25563b73fed0123d18a2556b9ba01d2c76b.patch
Patch0002: https://gitlab.freedesktop.org/freetype/freetype/-/commit/17545d4bf72175a8ea8020dcbd4d462234d2b5d0.patch
Patch0003: https://gitlab.freedesktop.org/freetype/freetype/-/commit/2a790a9f4937c3950028bd3de29e63c6b0d419ce.patch
Patch0004: https://gitlab.freedesktop.org/freetype/freetype/-/commit/57c4252ab5f435c52e66b619bd514068f7a683b0.patch
Patch0005: https://gitlab.freedesktop.org/freetype/freetype/-/commit/2b9fdec5fafd16fba93a9947563260ab9feb9029.patch
Patch0006: https://gitlab.freedesktop.org/freetype/freetype/-/commit/93a067e31240058103ce04057dd76dcf98c18d15.patch
Patch0007: https://gitlab.freedesktop.org/freetype/freetype/-/commit/37cefe33b284d0bad4ec52bcccc1a8c2d8704340.patch
Patch0008: https://gitlab.freedesktop.org/freetype/freetype/-/commit/b1cbcb20454e3b465b0d3ea4d5457975cfa747e7.patch
Patch0009: https://gitlab.freedesktop.org/freetype/freetype/-/commit/db83e9c0ec8b4ec8d7fa3bb3383d5160d1cfa719.patch
Patch0010: https://gitlab.freedesktop.org/freetype/freetype/-/commit/d091bca546fa15928db36c8447e126ee43ddb5f4.patch
Patch0011: https://gitlab.freedesktop.org/freetype/freetype/-/commit/1452355de99d22b0cba6ccc17bf5cdf3682ef61e.patch
# Enable subpixel rendering
Patch3000:  freetype-2.3.0-enable-spr.patch

BuildRequires: gcc make 
BuildRequires: libX11-devel libpng-devel zlib-devel
BuildRequires: bzip2-devel brotli-devel
%if %{without bootstrap}
BuildRequires: harfbuzz-devel
%endif
Provides:      %{name}-bytecode
Provides:      %{name}-subpixel

%description
FreeType is a freely available software library to render fonts.
It is written in C, designed to be small, efficient, highly customizable,
and portable while capable of producing high-quality output (glyph images)
of most vector and bitmap font formats.


%package devel
Summary:       FreeType development libraries and header files
Requires:      %{name} = %{version}-%{release}
Requires:      pkgconf

%description devel
The package includes libraries and header files for FreeType.


%package demos
Summary:       FreeType demos
Requires:      %{name} = %{version}-%{release}

%description demos
The package includes utilities showing various capabilities of the FreeType library.


%prep
%setup -q -b 1 -a 2
%autopatch -p1


%build
%configure --disable-static \
           --with-zlib=yes \
           --with-bzip2=yes \
           --with-png=yes \
           --enable-freetype-config \
           --with-brotli=yes \
%if %{without bootstrap}
           --with-harfbuzz=yes
%else
           --with-harfbuzz=no
%endif

sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' builds/unix/libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' builds/unix/libtool
%make_build
# Build demos
pushd ft2demos-%{version}
make TOP_DIR=".."
popd


%install
%make_install
#for ft2demos
for ftdemo in ftbench ftdump ftlint ftvalid ftdiff ftgamma ftgrid ftmulti ftstring ftview; do
    builds/unix/libtool --mode=install install -m 755 ft2demos-%{version}/bin/$ftdemo $RPM_BUILD_ROOT/%{_bindir}
done
for ftdemo in ftbench ftdump ftlint ftvalid ftdiff ftgamma ftgrid ftmulti ftstring ftview; do
    builds/unix/libtool --mode=install install -m 644 ft2demos-%{version}/man/${ftdemo}.1 $RPM_BUILD_ROOT/%{_mandir}/man1
done

rm -f $RPM_BUILD_ROOT%{_libdir}/*.la


%files
%license LICENSE.TXT docs/FTL.TXT docs/GPLv2.TXT
%doc README
%{_libdir}/libfreetype.so.*


%files devel
%doc docs/CHANGES docs/formats.txt docs/ft2faq.html
%doc docs/design docs/glyphs docs/reference docs/tutorial
%dir %{_includedir}/freetype2
%{_includedir}/freetype2/*
%{_libdir}/libfreetype.so
%{_libdir}/pkgconfig/freetype2.pc
%{_bindir}/freetype-config
%{_datadir}/aclocal/freetype2.m4
%{_mandir}/man1/freetype-config.1.gz

%files demos
%doc ChangeLog README
%{_bindir}/ft*
%{_mandir}/man1/ft*


%changelog
* Tue Jan 21 2025 Tracker Robot <trackbot@opencloudos.tech> - 2.13.1-17
- [Type] other
- [DESC] Apply patches from rpm-tracker
- [Performance] 1452355de99d22b0cba6ccc17bf5cdf3682ef61e.patch: * src/truetype/ttobjs.c (tt_size_run_prep): Correct scaling of CVT values.

* Fri Jan 17 2025 Tracker Robot <trackbot@opencloudos.tech> - 2.13.1-16
- [Type] bugfix
- [DESC] Apply patches from rpm-tracker
- [Bug Fix] d091bca546fa15928db36c8447e126ee43ddb5f4.patch: [cache] Fix error handling.

* Fri Jan 17 2025 Tracker Robot <trackbot@opencloudos.tech> - 2.13.1-15
- [Type] bugfix
- [DESC] Apply patches from rpm-tracker
- [Bug Fix] db83e9c0ec8b4ec8d7fa3bb3383d5160d1cfa719.patch: * src/cache/ftcglyph.c [!FTC_INLINE]: Fix compilation.

* Thu Jan 16 2025 Tracker Robot <trackbot@opencloudos.tech> - 2.13.1-14
- [Type] bugfix
- [DESC] Apply patches from rpm-tracker
- [Bug Fix] 37cefe33b284d0bad4ec52bcccc1a8c2d8704340.patch: * psobjs.c (ps_table_add): Check length before calling FT_MEM_CPY.
- [Bug Fix] b1cbcb20454e3b465b0d3ea4d5457975cfa747e7.patch: [ttgxvar] Avoid applying zero offset to null pointer

* Thu Jan 16 2025 Tracker Robot <trackbot@opencloudos.tech> - 2.13.1-13
- [Type] bugfix
- [DESC] Apply patches from rpm-tracker
- [Bug Fix] 2b9fdec5fafd16fba93a9947563260ab9feb9029.patch: * src/pfr/pfrgload.c (pfr_glyph_curve_to): Avoid casting.
- [Bug Fix] 93a067e31240058103ce04057dd76dcf98c18d15.patch: [base, autofit, psaux] Remove unnecessary casting.

* Wed Jan 15 2025 Tracker Robot <trackbot@opencloudos.tech> - 2.13.1-12
- [Type] bugfix
- [DESC] Apply patches from rpm-tracker
- [Bug Fix] 57c4252ab5f435c52e66b619bd514068f7a683b0.patch: [sfnt] Guard access in COLR v1 glyph binary search.

* Wed Jan 15 2025 Tracker Robot <trackbot@opencloudos.tech> - 2.13.1-11
- [Type] bugfix
- [DESC] Apply patches from rpm-tracker
- [Bug Fix] 2a790a9f4937c3950028bd3de29e63c6b0d419ce.patch: [cff, truetype] Always set up default variable instance.

* Tue Jan 14 2025 Tracker Robot <trackbot@opencloudos.tech> - 2.13.1-10
- [Type] other
- [DESC] Apply patches from rpm-tracker
- [Performance] 17545d4bf72175a8ea8020dcbd4d462234d2b5d0.patch: Avoid n^2 scanning for binary data.

* Tue Jan 14 2025 Tracker Robot <trackbot@opencloudos.tech> - 2.13.1-9
- [Type] bugfix
- [DESC] Apply patches from rpm-tracker
- [Bug Fix] f42ce25563b73fed0123d18a2556b9ba01d2c76b.patch: [colr] Ensure enough bytes for PaintColrLayers

* Mon Dec 23 2024 Miaojun Dong <zoedong@tencent.com> - 2.13.1-8
- Non-boostrap build and build with harfbuzz 8.1.1-6.

* Thu Dec 19 2024 Miaojun Dong <zoedong@tencent.com> - 2.13.1-7
- Bootstrap build to avoid requiring harfbuzz for harfbuzz building.

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.13.1-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.13.1-5
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.13.1-4
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 24 2023 rockerzhu <rockerzhu@tencent.com> - 2.13.1-3
- Non-boostrap build and build with harfbuzz 8.1.1.

* Wed Aug 23 2023 rockerzhu <rockerzhu@tencent.com> - 2.13.1-2
- Bootstrap build to avoid requiring harfbuzz for harfbuzz building.

* Fri Jul 28 2023 rockerzhu <rockerzhu@tencent.com> - 2.13.1-1
- Update to 2.13.1

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.12.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.12.1-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Jun 17 2022 rockerzhu <rockerzhu@tencent.com> - 2.12.1-1
- Initial build
